/* ccgo: sgf/tree.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "tree.hh"
#include "sgf.hh"
#include <cctype>
#include <sstream>
using namespace std;
using namespace sgf;

bool Tree::load(istream & f)
{
	node_list.clear();
	sub_trees.clear();
	// skip_til_char(f, '('); // find the tree start
	skip_white(f);
	if (f.eof() || f.peek() != '(') return false; // no tree!
	f.get();
	Node n;
	while (n.load(f)) node_list.push_back(n); // read nodes
	if (node_list.size() < 1) return false;
	Tree t;
	while (t.load(f)) sub_trees.push_back(t);
	skip_white(f);
	if (f.eof() || f.peek() != ')') {
		node_list.clear();
		sub_trees.clear();
		return false;
	}
	f.get();
	return true;
}

void Tree::save(ostream & f) const
{
	f << "(";
	for (vector<Node>::const_iterator i = node_list.begin(); i != node_list.end(); i ++)
		i->save(f);
	for (vector<Tree>::const_iterator i = sub_trees.begin(); i != sub_trees.end(); i ++)
		i->save(f);
	f << ")"; // << endl;
}

const vector<Node> & Tree::get_node_list() const
{
	return node_list;
}

const vector<Tree> & Tree::get_sub_trees() const
{
	return sub_trees;
}
